summaryrefslogtreecommitdiff
path: root/tests/dd/reblock
diff options
context:
space:
mode:
authorJim Meyering <meyering@redhat.com>2008-11-21 23:12:17 +0100
committerJim Meyering <meyering@redhat.com>2008-11-22 10:31:08 +0100
commita5e53ecc2cf8404760094631a772d4ce255bdcac (patch)
treed506765efafb9bad7ef69276d2a32cb3895d1005 /tests/dd/reblock
parentd5ab05998ca068b9a2e217285b15318ad2e5bdb8 (diff)
downloadcoreutils-a5e53ecc2cf8404760094631a772d4ce255bdcac.tar.xz
tests: dd: add a test for the required behavior
* tests/dd/reblock: New file. Test for the required functionality. Based on an example and discussion from this thread: http://lists.gnu.org/archive/html/bug-coreutils/2008-11/msg00153.html * tests/Makefile.am (TESTS): Add dd/reblock.
Diffstat (limited to 'tests/dd/reblock')
-rwxr-xr-xtests/dd/reblock51
1 files changed, 51 insertions, 0 deletions
diff --git a/tests/dd/reblock b/tests/dd/reblock
new file mode 100755
index 000000000..542529a71
--- /dev/null
+++ b/tests/dd/reblock
@@ -0,0 +1,51 @@
+#!/bin/sh
+# test dd reblocking vs. bs=
+
+# Copyright (C) 2008 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ dd --version
+fi
+
+. $srcdir/lang-default
+. $srcdir/test-lib.sh
+
+cat <<\EOF > exp-reblock || framework_failure
+0+2 records in
+1+1 records out
+4 bytes (4 B) copied
+EOF
+
+cat <<\EOF > exp-no-reblock || framework_failure
+0+2 records in
+0+2 records out
+4 bytes (4 B) copied
+EOF
+
+fail=0
+
+# ensure that dd reblocks when bs= is not specified
+(echo x; sleep .1; echo y) | dd ibs=3 obs=3 > out 2> err || fail=1
+sed 's/,.*//' err > k && mv k err
+compare err exp-reblock || fail=1
+
+# Demonstrate that bs=N supersedes even following ibs= and obs= settings.
+(echo x; sleep .1; echo y) | dd bs=3 ibs=1 obs=1 > out 2> err || fail=1
+sed 's/,.*//' err > k && mv k err
+compare err exp-no-reblock || fail=1
+
+Exit $fail